###################################################
### chunk number 1: 
###################################################
library(rpart)


###################################################
### chunk number 2: 
###################################################
data(Boston,package='MASS')


###################################################
### chunk number 3: 
###################################################
help('Boston',package='MASS')


###################################################
### chunk number 4: 
###################################################
arv <- rpart(medv ~ .,Boston)


###################################################
### chunk number 5: 
###################################################
arv


###################################################
### chunk number 6: 
###################################################
plot(arv)
text(arv)


###################################################
### chunk number 7: 
###################################################
plot(arv)
text(arv)


###################################################
### chunk number 8: 
###################################################
plot(arv,uniform=T,branch=0.2,margin=0.1,compress=T)
text(arv,fancy=T,cex=0.7,font=10,fwidth=0.5,fheight=0.7,use.n=T,all=T,digits=2,pretty=0)


###################################################
### chunk number 9: 
###################################################
plot(arv,uniform=T,branch=0.2,margin=0.1,compress=T)
text(arv,fancy=T,cex=0.7,font=10,fwidth=0.5,fheight=0.7,use.n=T,all=T,digits=2,pretty=0)


###################################################
### chunk number 10: 
###################################################
printcp(arv)


###################################################
### chunk number 11: 
###################################################
plotcp(arv)


###################################################
### chunk number 12: 
###################################################
prune(arv,cp=0.034)


###################################################
### chunk number 13: 
###################################################
arv.prun <- prune(arv,cp=0.034)


###################################################
### chunk number 14: 
###################################################
arv.grande <- rpart(medv ~ .,Boston,cp=0)
xval.prune.rpart <- function(tree,se=1) {
  lin.min.err <- which.min(tree$cptable[,4]) 
  tol.err <- tree$cptable[lin.min.err,4] + se * tree$cptable[lin.min.err,5]
  se.lin <- which(tree$cptable[,4] <= tol.err)[1]
  prune.rpart(tree,cp=tree$cptable[se.lin,1]+1e-7)
}
arv.final <- xval.prune.rpart(arv.grande)


###################################################
### chunk number 15: 
###################################################
arv.final


###################################################
### chunk number 16: 
###################################################
treino.idxs <- sample(nrow(Boston),
                     as.integer(0.7*nrow(Boston)))
treino <- Boston[treino.idxs,]
teste <- Boston[-treino.idxs,]
arv.grande <- rpart(medv ~ .,treino,cp=0)
arv.final <- xval.prune.rpart(arv.grande)
arv.prevs <- predict(arv.final,teste)
(mae.arv <- mean(abs(arv.prevs-teste[,'medv'])))
(mse.arv <- mean((arv.prevs-teste[,'medv'])^2))


