###################################################
### chunk number 1: 
###################################################
data(lh)
lh
class(lh)


###################################################
### chunk number 2: 
###################################################
serieTrimestral <- ts(rnorm(100),frequency=4,start=c(1990,2))
serieTrimestral


###################################################
### chunk number 3: 
###################################################
serieDiaria <- ts(rnorm(20),frequency=7,end=c(10,14))
serieDiaria
serieMensal <- ts(rnorm(30),frequency=12,start=c(2000,5))
serieMensal


###################################################
### chunk number 4: 
###################################################
plot(serieTrimestral)


###################################################
### chunk number 5: 
###################################################
window(serieTrimestral,start=c(1995,2),end=c(1999,4))
diff(window(serieTrimestral,start=c(1995,2),end=c(1999,4)))


###################################################
### chunk number 6: 
###################################################
acf(lh)


###################################################
### chunk number 7: 
###################################################
lh
mm4 <- filter(lh,rep(1/4,4),sides=1)
mm4


###################################################
### chunk number 8: 
###################################################
mm <- function(s,k) {
  filter(s,rep(1/k,k),sides=1)
}
mm(lh,5)


###################################################
### chunk number 9: 
###################################################
plot(lh)
lines(mm(lh,4),col='red')
legend(1,3.5,c('Srie','Mdia Mvel(4)'),col=c('black','red'),lty=c(1,1))


###################################################
### chunk number 10: 
###################################################
ema <- function (x, k, init = x[1]) 
{
  alfa <- 2/(k+1)
  filter(alfa*x, filter=1-alfa, method="recursive", init=init)
}
ema(lh,4)


###################################################
### chunk number 11: 
###################################################
plot(lh)
lines(ema(lh,5),lty=2,col='red')
lines(ema(lh,10),lty=2,col='blue')
legend(1,3.5,c('Srie','ema(5)','ema(10)'),col=c('black','red','blue'),lty=c(1,2,2))


###################################################
### chunk number 12: 
###################################################
ar(lh,order.max=5)
ar(lh,aic=F,order.max=4)


###################################################
### chunk number 13: 
###################################################
arima(lh,c(3,1,2))


###################################################
### chunk number 14: 
###################################################
ar4 <- ar(lh,aic=F,order.max=4)
arima312 <- arima(lh,c(3,1,2))
preds.ar4 <- predict(ar4,n.ahead=5)$pred
preds.arima312 <- predict(arima312,n.ahead=5)$pred
plot(c(lh,preds.ar4),type='n')
lines(lh)
lines(preds.ar4,col='red')
lines(preds.arima312,col='blue')
legend(1,3.5,c('Srie','Previses AR(4)','Previses ARIMA(3,1,2)'),lty=c(1,1,1),col=c('black','red','blue'))


###################################################
### chunk number 15: 
###################################################
ar4 <- ar(lh,aic=F,order.max=4)
arima312 <- arima(lh,c(3,1,2))
preds.ar4 <- predict(ar4,n.ahead=5)$pred
preds.arima312 <- predict(arima312,n.ahead=5)$pred
plot(c(lh,preds.ar4),type='n')
lines(lh)
lines(preds.ar4,col='red')
lines(preds.arima312,col='blue')
legend(1,3.5,c('Srie','Previses AR(4)','Previses ARIMA(3,1,2)'),lty=c(1,1,1),col=c('black','red','blue'))


###################################################
### chunk number 16: 
###################################################
(HW <- HoltWinters(AirPassengers))


###################################################
### chunk number 17: 
###################################################
plot(HW)


###################################################
### chunk number 18: 
###################################################
t.train <- window(AirPassengers,end=c(1955,12))
t.modsel <- window(AirPassengers,start=c(1956,1),end=c(1957,12))
t.test <- window(AirPassengers,start=c(1958,1))
t.train.best <- window(AirPassengers,end=c(1957,12))


###################################################
### chunk number 19: 
###################################################
lh
head(embed(lh,dim=4))


###################################################
### chunk number 20: 
###################################################
train <- data.frame(embed(diff(t.train),dim=6))
names(train) <- c('dt','dt.1','dt.2','dt.3','dt.4','dt.5')
head(train)
sel <- data.frame(embed(diff(t.modsel),dim=6))
test <- data.frame(embed(diff(t.test),dim=6))
train.best <- data.frame(embed(diff(t.train.best),dim=6))
names(sel) <- names(test) <- names(train.best) <- c('dt','dt.1','dt.2','dt.3','dt.4','dt.5')


###################################################
### chunk number 21: 
###################################################
library(nnet)
alt <- expand.grid(size=c(10,20),decay=c(0.01,0.001),theil=0)
prevs.ant <- c(train[nrow(train),'dt'],sel[1:(nrow(sel)-1),'dt'])
for(a in 1:nrow(alt)) {
  nn <- nnet(dt ~ ., train,size=alt[a,'size'],decay=alt[a,'decay'],
             maxit=1000,linout=T)
  prevs <- predict(nn,sel)
  alt[a,'theil'] <- sqrt(sum(((sel[,'dt']-prevs)/prevs.ant)^2)/
                         sum(((sel[,'dt']-prevs.ant)/prevs.ant)^2))
}
best <- which.min(alt[,'theil'])


###################################################
### chunk number 22: 
###################################################
nn <- nnet(dt ~ ., train.best,size=alt[best,'size'],decay=alt[best,'decay'],
             maxit=1000,linout=T)
prevs.ant <- c(train.best[nrow(train.best),'dt'],test[1:(nrow(test)-1),'dt'])
prevs <- predict(nn,test)
theil <- sqrt(sum(((test[,'dt']-prevs)/prevs.ant)^2)/
              sum(((test[,'dt']-prevs.ant)/prevs.ant)^2))


