###################################################
### chunk number 1: 
###################################################
library(class)


###################################################
### chunk number 2: 
###################################################
data(iris)
summary(iris)


###################################################
### chunk number 3: 
###################################################
help('iris')


###################################################
### chunk number 4: 
###################################################
train.idxs <- sample(nrow(iris),as.integer(0.7*nrow(iris)))
train <- iris[train.idxs,]
test <- iris[-train.idxs,]


###################################################
### chunk number 5: 
###################################################
prevs.1NN <- knn(train[,-5],test[,-5],train[,5])


###################################################
### chunk number 6: 
###################################################
(conf.mtrx.1NN <- table(prevs.1NN,test[,5])) 


###################################################
### chunk number 7: 
###################################################
(acc.1NN <- sum(diag(conf.mtrx.1NN))/sum(conf.mtrx.1NN)*100)


###################################################
### chunk number 8: 
###################################################
prevs.3NN <- knn(train[,-5],test[,-5],train[,5],k=3)
(conf.mtrx.3NN <- table(prevs.3NN,test[,5]))
(acc.3NN <- sum(diag(conf.mtrx.3NN))/sum(conf.mtrx.3NN)*100)
prevs.5NN <- knn(train[,-5],test[,-5],train[,5],k=5)
conf.mtrx.5NN <- table(prevs.3NN,test[,5])
(acc.5NN <- sum(diag(conf.mtrx.5NN))/sum(conf.mtrx.5NN)*100)


###################################################
### chunk number 9: 
###################################################
resultados <- c(acc.1NN,acc.3NN,acc.5NN)
names(resultados) <- c('1-NN','3-NN','5-NN')
resultados
round(resultados,3)


###################################################
### chunk number 10: 
###################################################
ll0 <- loess(dist ~ speed,data=cars,degree=0,span=0.2) 


###################################################
### chunk number 11: 
###################################################
ll1 <- loess(dist ~ speed,data=cars,degree=1)
ll2 <- loess(dist ~ speed,data=cars)


###################################################
### chunk number 12: 
###################################################
plot(cars$speed, cars$dist,main= 'Distncia de travagem',xlab= 'Velocidade',ylab= 'Distncia')
abline(lm(dist ~ speed,data=cars))
lines(cars$speed,fitted(ll0),col='red')
lines(cars$speed,fitted(ll1),col='blue')
lines(cars$speed,fitted(ll2),col='green')
legend(5,120,c('lin.regr','kernel (20%)','local linear','local pol. (2)'),col=c('black','red','blue','green'),lty=1)


###################################################
### chunk number 13: 
###################################################
plot(cars$speed, cars$dist,main= 'Distncia de travagem',xlab= 'Velocidade',ylab= 'Distncia')
abline(lm(dist ~ speed,data=cars))
lines(cars$speed,fitted(ll0),col='red')
lines(cars$speed,fitted(ll1),col='blue')
lines(cars$speed,fitted(ll2),col='green')
legend(5,120,c('lin.regr','kernel (20%)','local linear','local pol. (2)'),col=c('black','red','blue','green'),lty=1)


###################################################
### chunk number 14: 
###################################################
train.idxs <- sample(nrow(cars),as.integer(0.7*nrow(cars)))
train <- cars[train.idxs,]
test <- cars[-train.idxs,]


###################################################
### chunk number 15: 
###################################################
loc0 <- loess(dist ~ speed, train, degree=0,span=0.2)
preds.loc0 <- predict(loc0,test)
loc1 <- loess(dist ~ speed, train, degree=1)
preds.loc1 <- predict(loc1,test)
loc2 <- loess(dist ~ speed, train, degree=2)
preds.loc2 <- predict(loc2,test)


###################################################
### chunk number 16: 
###################################################
(mse.loc0 <- mean((preds.loc0-test[,ncol(test)])^2))
(mse.loc1 <- mean((preds.loc1-test[,ncol(test)])^2))
(mse.loc2 <- mean((preds.loc2-test[,ncol(test)])^2))


###################################################
### chunk number 17: 
###################################################
plot(preds.loc1,test[,ncol(test)],xlab='Valores previstos',ylab='Valores previstos',main='As previses dos modelos loc0, loc1 e loc2',col='red',ylim=range(c(preds.loc1,preds.loc2),na.rm=T))
points(preds.loc0,test[,ncol(test)],col='blue')
points(preds.loc2,test[,ncol(test)],col='green')
abline(0,1,lty=2)
legend(10,60,c('loc0','loc1','loc2'),col=c('blue','red','green'),lty=c(1,1,1))


###################################################
### chunk number 18: 
###################################################
plot(preds.loc1,test[,ncol(test)],xlab='Valores previstos',ylab='Valores previstos',main='As previses dos modelos loc0, loc1 e loc2',col='red',ylim=range(c(preds.loc1,preds.loc2),na.rm=T))
points(preds.loc0,test[,ncol(test)],col='blue')
points(preds.loc2,test[,ncol(test)],col='green')
abline(0,1,lty=2)
legend(10,60,c('loc0','loc1','loc2'),col=c('blue','red','green'),lty=c(1,1,1))


###################################################
### chunk number 19: 
###################################################
loc2.extr <- loess(dist ~ speed, train, degree=2,control=loess.control(surface = "direct"))
preds.loc2.extr <- predict(loc2.extr,test)


