###################################################
### chunk number 1: 
###################################################
library(nnet)


###################################################
### chunk number 2: 
###################################################
data(Boston,package='MASS')


###################################################
### chunk number 3: 
###################################################
help('Boston',package='MASS')


###################################################
### chunk number 4: 
###################################################
nn <- nnet(medv ~ ., Boston,size=20,decay=0.001,maxit=1000,linout=T)


###################################################
### chunk number 5: 
###################################################
nn


###################################################
### chunk number 6: 
###################################################
summary(nn)


###################################################
### chunk number 7: 
###################################################
treino.idxs <- sample(nrow(Boston),
                     as.integer(0.7*nrow(Boston)))
treino <- Boston[treino.idxs,]
teste <- Boston[-treino.idxs,]
nn <- nnet(medv ~ ., treino,size=20,decay=0.001,maxit=1000,linout=T)
nn.prevs <- predict(nn,teste)
(mae.nn <- mean(abs(nn.prevs-teste[,'medv'])))
(mse.nn <- mean((nn.prevs-teste[,'medv'])^2))


###################################################
### chunk number 8: 
###################################################
plot(teste[,'medv'],nn.prevs,main='Previses da rede neuronal',ylab='Previses',xlab='Valores verdadeiros')
abline(0,1,lty=2,col='red')


###################################################
### chunk number 9: 
###################################################
plot(teste[,'medv'],nn.prevs,main='Previses da rede neuronal',ylab='Previses',xlab='Valores verdadeiros')
abline(0,1,lty=2,col='red')


###################################################
### chunk number 10: 
###################################################
config.nn <- function(Alternativas,Dados) {
  Alternativas$MSE <- rep(NA,nrow(Alternativas))

  treino.idxs <- sample(nrow(Dados),
                        as.integer(0.7*nrow(Dados)))
  treino <- Dados[treino.idxs,]
  teste <- Dados[-treino.idxs,]

  for(a in 1:nrow(Alternativas)) {
    nn <- nnet(as.formula(paste(colnames(treino)[ncol(treino)],'~ .')),
               treino,size=Alternativas[a,'size'],decay=Alternativas[a,'decay'],
               maxit=1000,linout=T)
    prevs <- predict(nn,teste)
    Alternativas[a,'MSE'] <- mean((teste[,ncol(teste)]-prevs)^2)
  }

  list(Resultados=Alternativas,Melhor=Alternativas[which.min(Alternativas$MSE),])
}


###################################################
### chunk number 11: 
###################################################
res <- config.nn(expand.grid(size=c(10,20),decay=c(0.01,0.001)),Boston)


###################################################
### chunk number 12: 
###################################################
res


